#include <iostream>
#include <vector>

class bag {
  public:
    bag(int c)
    {
        cap = c;
        data = new int[cap];
    }

    ~bag()
    {
        delete[] data;
    }

    bag(const bag& original)
    {
        sz = original.size();
        cap = original.capacity();

        data = new int[cap];
        for(int i = 0; i < sz; ++i)
            data[i] = original.data[i];
    }

    bag& operator= (const bag& original)
    {
        delete[] data;

        sz = original.sz;
        cap = original.cap;

        data = new int[cap];
        for(int i = 0; i < sz; ++i)
            data[i] = original.data[i];

        return *this;        
    }

    int capacity() const { return cap; }
    int size()     const { return sz; }

    bool empty()  const { return size() == 0; }
    bool full()   const { return size() == capacity(); }

    void print() const
    {
        for(int i = 0; i < size(); ++i)
            std::cout << data[i] << " ";
        std::cout << std::endl;
    }

    void insert(int x)
    {
        if(full())
            return;

        ++sz;
        data[sz-1] = x;
    }

    void remove(int x)
    {
        for(int i = 0; i < size(); ++i)
            if(data[i] == x) {
                std::swap(data[i], data[sz-1]);
                --sz;
                return;
            }
    }

  private:
    int* data = nullptr;
    int cap;
    int sz = 0;
};

int main()
{
    using std::cout;
    using std::endl;
    
    bag b(10);

    cout << b.capacity() << endl; // Print 10
    cout << b.size() << endl;     // Print 0

    if(b.empty()) 
        cout << "Empty" << endl;

    if(b.full())
        cout << "Full" << endl;

    b.insert(2); 
    b.insert(7);
    b.insert(-8);

    b.print();

    b.remove(2);

    b.print();

    b.insert(10);

    b.print();

    bag c(b); // c = { 7, -8, 10 }

    c.remove(7);
    c.remove(-8);
    c.insert(-100);
    // c.insert(-200);

    // c = { 10, -100 }
    // b = { 7, -8, 10 }

    cout << "c: "; c.print();
    cout << "b: "; b.print();   
}