#include <iostream>
#include <vector>

class bag {
  public:
    bag(int c)
    {
        data.resize(c);
    }

    int capacity() { return data.size(); }
    int size()     { return sz; }

    bool empty()   { return size() == 0; }
    bool full()    { return size() == capacity(); }

    void print()
    {
        for(int i = 0; i < size(); ++i)
            std::cout << data[i] << " ";
        std::cout << std::endl;
    }

    void insert(int x)
    {
        if(full())
            return;

        ++sz;
        data[sz-1] = x;
    }

    void remove(int x)
    {
        for(int i = 0; i < size(); ++i)
            if(data[i] == x) {
                std::swap(data[i], data[sz-1]);
                --sz;
                return;
            }
    }

  private:
    std::vector<int> data;
    int sz = 0;
};

int main()
{
    using std::cout;
    using std::endl;
    
    bag b(10);

    cout << b.capacity() << endl; // Print 10
    cout << b.size() << endl;     // Print 0

    if(b.empty()) 
        cout << "Empty" << endl;

    if(b.full())
        cout << "Full" << endl;

    b.insert(2); 
    b.insert(7);
    b.insert(-8);

    b.print();

    b.remove(2);

    b.print();

    b.insert(10);

    b.print();

    bag c = b;
}