#include <iostream>
#include <stack>
#include <string>
#include <vector>
using namespace std;

vector<string> split(string in)
{
    in.push_back(' ');

    enum { SPACE, WORD } state = SPACE;
    vector<string> words;
    string w; // Current word

    for(char c : in) {
        if(c == ' ' and state == SPACE) {
            // Ignore
        }
        else if(c != ' ' and state == SPACE) {
            // Start new word
            w = "";
            w.push_back(c);
            state = WORD;
        }
        else if(c == ' ' and state == WORD) {
            // Finish word
            words.push_back(w);
            state = SPACE;
        }
        else if(c != ' ' and state == WORD) {
            // Add to word
            w.push_back(c);
        }
    }

    if(state == WORD)
        words.push_back(w);

    return words;
}

int main()
{
    stack<int> st;

    while(true) {
        cout << "> ";
        string input;
        getline(cin, input);
        vector<string> words = split(input);

        for(string s : words) {
            if(s[0] >= '0' and s[0] <= '9')
                st.push(stoi(s));
            else if(s == "+" or s == "-" or 
                    s == "*" or s == "/") {

                int a = st.top(); 
                st.pop();

                int b = st.top();
                st.pop();

                if     (s == "+") st.push(a + b);            
                else if(s == "-") st.push(a - b);
                else if(s == "*") st.push(a * b);
                else if(s == "/") st.push(a / b);
            }
        }
        
        if(not st.empty())
            cout << st.top() << endl;
        
    }
}






